public class InsertionSort {

	public static <T extends Comparable<T>> T[] sort(T[] arr) {
		for (int i = 0; i < arr.length; ++i) {
			for (int j = i - 1; j >= 0; --j) {
				if (arr[j].compareTo(arr[j + 1]) > 0) {
					T tmp = arr[j];
					arr[j] = arr[j+1];
					arr[j+1] = tmp;
				} else break;
			}
		}
		return arr;
	}
	
	public static void main(String[] args) {
		// Integer[] arr = SortUtils.generateRandomSeq(10, 20);
		Integer[] arr = SortUtils.generateRandomPermutation(20);
		sort(arr);
		
		System.out.println(SortUtils.isSorted(arr));
		SortUtils.displayArr(arr);
		
		TimingUtils.computeAvg(
				x -> sort(x), 
				SortUtils.generateMultipleRandomSeqs(10, 10000, 1000));
	}
	
}
