let rec take i = function
| [] -> []
| x::xs ->
   if i > 0 then x :: take (i - 1) xs
   else [];;

let rec drop i = function
| [] -> []
| x::xs ->
   if i > 0 then drop (i-1) xs
   else x::xs;;

let rec merge = function
| [], ys -> ys
| xs, [] -> xs
| x::xs, y::ys ->
   if x <= y then x :: merge (xs, y::ys)
   else y :: merge (x::xs, ys);;

let rec tmergesort = function
| [] -> []
| [x] -> [x]
| xs ->
  let k = List.length xs / 2 in
  let l = tmergesort (take k xs) in
  let r = tmergesort (drop k xs) in
   merge (l, r);;
