import java.util.ArrayList;
import java.util.Arrays;

public class MostFrequentElement {
	
	public static ArrayList<Integer> mostFrequentElements(int[] a) {
		ArrayList<Integer> out = new ArrayList<>();
		if (a.length == 0) return out;
		Arrays.sort(a);
		int prev = a[0];
		int cnt = 1, max_cnt = 1;
		out.add(prev);
		for (int i = 1; i < a.length; ++i) {
			if (a[i] == prev) {
				++cnt;
			} else {
				prev = a[i];
				cnt = 1;
			}
			// Update the maximum count and update the
			// collection of items with maximum frequency.
			if (cnt == max_cnt) {
				out.add(a[i]);
			} else if (cnt > max_cnt) {
				out.clear();
				out.add(a[i]);
				max_cnt = cnt;
			}
		}
		return out;
	}
	
	public static void main(String[] args) {
		int[] a = {1, 2, 1, 1, 3, 3, 2, 4, 3};
		ArrayList<Integer> out = mostFrequentElements(a);
		for (int x : out) {
			System.out.println(x);
		}
	}

}
