public class MergeSort {

	static void merge(Integer arr[], int l, int m, int r) {
		Integer tmp[] = new Integer[r - l + 1];
		int i1 = l, i2 = m + 1;
		for (int i = 0; i <= r - l; ++i) {
			if (i2 == r + 1 || (i1 <= m && arr[i1] < arr[i2])) {
				tmp[i] = arr[i1];
				++i1;
			} else {
				tmp[i] = arr[i2];
				++i2;
			}
		}
		for (int j = 0; j < tmp.length; ++j) {
			arr[l + j] = tmp[j];
		}
	}

	static Integer[] mergeSort(Integer[] arr, int l, int r) {
		if (r <= l)
			return arr;
		int m = (l + r) / 2;
		mergeSort(arr, l, m);
		mergeSort(arr, m + 1, r);
		merge(arr, l, m, r);
		return arr;
	}
}
