class Solution{
    public static int doUnion(int a[], int n, int b[], int m) 
    {
        Arrays.sort(a, 0, n);
        Arrays.sort(b, 0, m);
        
        int i1 = 0, i2 = 0;
        ArrayList<Integer> union = new ArrayList<>();
        while (i1 < n && i2 < m) {
            if (a[i1] == b[i2]) {
                int cur = a[i1];
                union.add(cur);
                // Remove all elements equal to the currently 
                // added element from each array.
                while (i1 < n && cur == a[i1]) ++i1;
                while (i2 < m && cur == b[i2]) ++i2;
            } else if (a[i1] < b[i2]) {
                int cur = a[i1];
                union.add(cur);
                while (i1 < n && cur == a[i1]) ++i1;
            } else {
                int cur = b[i2];
                union.add(cur);
                while (i2 < m && cur == b[i2]) ++i2;
            }
        }
        while (i1 < n) {
            int cur = a[i1];
            union.add(cur);
            while (i1 < n && cur == a[i1]) ++i1;
        }
        while (i2 < m) {
            int cur = b[i2];
            union.add(cur);
            while (i2 < m && cur == b[i2]) ++i2;
        }
        return union.size();
    }
}
