class Solution {
   public int[] intersect(int[] nums1, int[] nums2) {
      Arrays.sort(nums1);
      Arrays.sort(nums2);
        
      int i1 = 0, i2 = 0, j = 0;
      int[] out = new int[nums1.length + nums2.length];
      while (i1 < nums1.length && i2 <nums2.length) {
         if (nums1[i1] == nums2[i2]) {
            out[j] = nums2[i2];
            ++j;
            ++i1;
            ++i2;
         } else if (nums1[i1] < nums2[i2]) {
            ++i1;
         } else {
            ++i2;
         }
      }
      return Arrays.copyOfRange(out, 0, j);
   }
}
